'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _seleniumWebdriver = require('selenium-webdriver');

var _seleniumWebdriver2 = _interopRequireDefault(_seleniumWebdriver);

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-env browser */

const getNewBrowser = () => _seleniumWebdriver2.default.promise.createFlow(controlFlow => new _seleniumWebdriver2.default.Builder().setControlFlow(controlFlow).forBrowser(process.env.HEADLESS ? 'phantomjs' : process.env.BROWSER || 'chrome').build());

class Browser {
  constructor(driver) {
    this.driver = driver;
    // @todo make this configurable, 15 minutes is too long for most things,
    // and probably not enough for all use cases.
    driver.manage().timeouts().setScriptTimeout(15 * 60 * 1000);
  }
  navigate(url) {
    this._currentUrl = url;
    return _bluebird2.default.join(this.driver.get(url));
  }
  executeScript(script) {
    return _bluebird2.default.join(this.driver.executeScript(script));
  }
  executeAsyncScript(...args) {
    return _bluebird2.default.join(this.driver.executeAsyncScript(...args));
  }
  quit() {
    this.driver.quit();
  }
}

exports.default = () => getNewBrowser().then(driver => new Browser(driver));