'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = filesParser;

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fp = require('lodash/fp');

var _fp2 = _interopRequireDefault(_fp);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_bluebird2.default.promisifyAll(_fs2.default);

function filesParser(files) {
  return _bluebird2.default.all(files.map(file => _fs2.default.statAsync(file).then(stats => {
    if (stats.isFile()) {
      return _path2.default.resolve(file);
    }

    if (stats.isDirectory()) {
      return _fs2.default.readdirAsync(file).then(_fp2.default.filter(x => x.match(/\.js$/))).then(_fp2.default.map(basename => _path2.default.resolve(file, basename)));
    }

    return undefined;
  }))).then(_fp2.default.flatten);
}