'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _requestPromise = require('request-promise');

var _requestPromise2 = _interopRequireDefault(_requestPromise);

var _cloneDeep = require('lodash/cloneDeep');

var _cloneDeep2 = _interopRequireDefault(_cloneDeep);

var _queueUtil = require('./lib/queue-util.js');

var _queueUtil2 = _interopRequireDefault(_queueUtil);

var _dataUtil = require('./lib/data-util.js');

var _dataUtil2 = _interopRequireDefault(_dataUtil);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

exports.default = (() => {
  var _ref = _asyncToGenerator(function* ({ queueItem, scraper }) {
    try {
      scraper.log('Downloading page');
      const noop = function (x) {
        return x;
      };
      const content = yield (0, _requestPromise2.default)({
        uri: (scraper.filterUrl || noop)(queueItem.url),
        resolveWithFullResponse: true,
        headers: {
          'User-Agent': queueItem.userAgent || 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/54.0.2840.59 Safari/537.36'
        }
      });
      scraper.log('Downloaded page');
      const utils = {
        body: content.body,
        queue: (0, _queueUtil2.default)(),
        data: (0, _dataUtil2.default)(),
        queueItem: (0, _cloneDeep2.default)(queueItem)
      };
      scraper.log('Calling user function');
      scraper[queueItem.method](utils);

      return {
        queue: utils.queue.getQueue(),
        data: utils.data.getData(),
        finalUrl: content.request.href
      };
    } catch (error) {
      scraper.error('BIGERR: An error occurred processing an item', error, 'from url: ', queueItem.url);
      throw error;
    }
  });

  function processRegex(_x) {
    return _ref.apply(this, arguments);
  }

  return processRegex;
})();